package cz.majner.chata.nasechata;


import android.app.Activity;
import android.app.PendingIntent;
import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;

import android.content.IntentFilter;
import android.content.SharedPreferences;
import android.os.AsyncTask;
import android.preference.PreferenceManager;
import android.telephony.SmsManager;
//import android.widget.Toast;


public class AthSmsRequest extends AsyncTask<String, Void, String> {

    public static final String NOTIFICATION = "cz.majner.chata.nasechata.CHATA_REMOTE_REQUEST";
    private Context mContext;
    private String mAction, smsProcesStatus;
    private Long mCommandID;
    SharedPreferences preferences;
    BroadcastReceiver smsSentReceiver, smsDeliveredReceiver;


    public AthSmsRequest(Context context, String sender, Long commandID)
    {
        mContext = context;
        mAction = sender;
        mCommandID = commandID;
    }

    @Override
    protected void onPreExecute() {
        super.onPreExecute();
        smsProcesStatus="init";
        //Toast.makeText(mContext, "pre", Toast.LENGTH_SHORT).show();
        smsSentReceiver=new BroadcastReceiver() {
            @Override
            public void onReceive(Context arg0, Intent arg1) {
                // Auto-generated method stub
                //Toast.makeText(mContext, "smsSentReceiver", Toast.LENGTH_SHORT).show();
                switch (getResultCode()) {
                    case Activity.RESULT_OK:
                        //Toast.makeText(mContext, "SMS has been sent", Toast.LENGTH_SHORT).show();
                        smsProcesStatus="SMS has been sent";
                        break;
                    case SmsManager.RESULT_ERROR_GENERIC_FAILURE:
                        //Toast.makeText(mContext, "Generic Failure", Toast.LENGTH_SHORT).show();
                        smsProcesStatus="Generic Failure";
                        break;
                    case SmsManager.RESULT_ERROR_NO_SERVICE:
                        //Toast.makeText(mContext, "No Service", Toast.LENGTH_SHORT).show();
                        smsProcesStatus="No Service";
                        break;
                    case SmsManager.RESULT_ERROR_NULL_PDU:
                        //Toast.makeText(mContext, "Null PDU", Toast.LENGTH_SHORT).show();
                        smsProcesStatus="Null PDU";
                        break;
                    case SmsManager.RESULT_ERROR_RADIO_OFF:
                        //Toast.makeText(mContext, "Radio Off", Toast.LENGTH_SHORT).show();
                        smsProcesStatus="Radio Off";
                        break;
                    default:
                        break;
                }

            }
        };
        smsDeliveredReceiver=new BroadcastReceiver() {
            @Override
            public void onReceive(Context arg0, Intent arg1) {
                // to-generated method stub
                switch(getResultCode()) {
                    case Activity.RESULT_OK:
                        //Toast.makeText(mContext, "SMS Delivered", Toast.LENGTH_SHORT).show();
                        smsProcesStatus="SMS Delivered";
                        break;
                    case Activity.RESULT_CANCELED:
                        //Toast.makeText(mContext, "SMS not delivered", Toast.LENGTH_SHORT).show();
                        smsProcesStatus="SMS not delivered";
                        break;
                }
            }
        };
        mContext.registerReceiver(smsSentReceiver, new IntentFilter("SMS_SENT"));
        mContext.registerReceiver(smsDeliveredReceiver, new IntentFilter("SMS_DELIVERED"));
    }


    @Override
    protected String doInBackground(String... parametry) {
        String vysledek;


        try {
            Intent intent1=new Intent(NOTIFICATION);
            intent1.putExtra("button_status", "false");
            mContext.sendBroadcast(intent1);

            preferences = PreferenceManager.getDefaultSharedPreferences(mContext);
            preferences.edit().putBoolean("buttons", false).apply();

            String toPhoneNumber = parametry[0];
            String smsMessage = parametry[1];
            long stopTime = preferences.getLong("pref_edit_ath_timeout", 120)*1000 + System.currentTimeMillis();


            try {
                SmsManager smsManager = SmsManager.getDefault();
                PendingIntent piSent=PendingIntent.getBroadcast(mContext, 0, new Intent("SMS_SENT"), 0);
                PendingIntent piDelivered= PendingIntent.getBroadcast(mContext, 0, new Intent("SMS_DELIVERED"), 0);
                smsManager.sendTextMessage(toPhoneNumber, null, smsMessage, piSent, piDelivered);
                //Toast.makeText(this, "SMS sent.",Toast.LENGTH_LONG).show();
                while (smsProcesStatus.equals("init")||(stopTime<System.currentTimeMillis())) {
                    //cekani na potvrzeni o odeslani SMS
                    Thread.sleep(10);
                }
                if (smsProcesStatus.equals("SMS has been sent")){
                    while (smsProcesStatus.equals("SMS has been sent")||(stopTime<System.currentTimeMillis())) {
                        //cekani na potvrzeni o doruceni SMS
                        Thread.sleep(10);
                    }
                    if (smsProcesStatus.equals("SMS Delivered")) {
                        //cekani na prichozi SMS od ATH
                        Thread.sleep(10000);
                        vysledek = "SMS_ANSWER:" + smsMessage;
                    }else{
                        vysledek = "SMS_ERROR:"+smsProcesStatus;
                    }

                }else{
                    vysledek = "SMS_ERROR:"+smsProcesStatus;
                }



            } catch (Exception e) {
                vysledek = "SMS_ERROR:"+smsProcesStatus;
                //Toast.makeText(getApplicationContext(),"Sending SMS failed.",Toast.LENGTH_LONG).show();
                //e.printStackTrace();
            }

        } catch (Exception e) {
            // we cannot do anything about that : network may be temporarily down
            //Log.d(MY_TAG, "HTTP request failed");
            vysledek = "SMS_ERROR:"+smsProcesStatus;
        }
        return vysledek;
    }

    @Override
    protected void onPostExecute(String vysledek) {

        preferences = PreferenceManager.getDefaultSharedPreferences(mContext);
        preferences.edit().putBoolean("buttons", true).apply();
        preferences.edit().putString("vysledek."+mAction, vysledek).apply();
        preferences.edit().putLong("commandID."+mAction, mCommandID).apply();

        Intent intent2=new Intent(NOTIFICATION + "."+mAction);
        intent2.putExtra("vysledek",vysledek);
        mContext.sendBroadcast(intent2);

        Intent intent3 = new Intent(NOTIFICATION);
        intent3.putExtra("button_status", "true");
        mContext.sendBroadcast(intent3);


        //nevim proc to nelze odregistrovat
        //mContext.unregisterReceiver(smsSentReceiver);
        //mContext.unregisterReceiver(smsDeliveredReceiver);


        //Toast.makeText(mContext, "post", Toast.LENGTH_SHORT).show();


    }
}

