package cz.majner.chata.nasechata;


import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.content.IntentFilter;
import android.content.SharedPreferences;
import android.graphics.Color;
import android.net.ConnectivityManager;
import android.net.NetworkInfo;
import android.net.Uri;
import android.os.Bundle;
import android.preference.PreferenceManager;
import android.support.v4.app.Fragment;

import android.telephony.PhoneStateListener;
import android.telephony.ServiceState;
import android.telephony.TelephonyManager;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.Button;
import android.widget.RadioButton;
import android.widget.Switch;
import android.widget.TextView;
import java.text.DateFormat;
import java.util.Date;



public class FragmentAth extends Fragment {

    private final static String CONNECTIVITY = "android.net.conn.CONNECTIVITY_CHANGE";
    public static final String NOTIFICATION = "cz.majner.chata.nasechata.CHATA_REMOTE_REQUEST";
    private ConnectivityManager cm;
    private TextView popisATHInternetStav, textViewATHStav, popisATHAKUStav, popisATHAKUtepStav,
            textViewATHHistory,popisATHTLOStav,popisATHTLOtepStav,popisATHTKOStav,popisATHBOJStav,textViewStavSMS;
    private Button buttonATHStav, buttonATHNastav;
    private Switch switchService;
    RadioButton rbZAK, rbVAK,rbTON, rbTOV, rbZTL, rbVTL, rbTLN, rbTLV, rbZTK, rbVTK, rbZBO, rbVBO;
    SharedPreferences preferences;


    private BroadcastReceiver receiver = new BroadcastReceiver() {
        @Override
        public void onReceive(Context context, Intent intent) {
            String action = intent.getAction();
            if (action.equals(CONNECTIVITY)) {
                updateNetworkStatus();
            }
            if (action.equals(NOTIFICATION)) {
                String button_status = intent.getStringExtra("button_status");
                if (button_status.equals("false")) {
                    nastavATHButtony(false);
                }
                if (button_status.equals("true")) {
                    nastavATHButtony(true);
                }
                //buttonOdeslat.setEnabled(true);
            }
            if (action.equals(NOTIFICATION + ".ATH")) {
                String vysledek = intent.getStringExtra("vysledek");
                zpracujATHVysledek(vysledek);

            }

        }
    };


    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container,
                             Bundle savedInstanceState) {

        super.onCreateView(inflater, container, savedInstanceState);
        //Toast.makeText(getActivity(), "CreateView",Toast.LENGTH_SHORT).show();


        View view = inflater.inflate(R.layout.fragment_ath, container, false);

        textViewStavSMS = (TextView) view.findViewById(R.id.textViewStavSMS);
        popisATHInternetStav = (TextView) view.findViewById(R.id.popisATHInternetStav);
        textViewATHHistory = (TextView) view.findViewById(R.id.textViewATHHistory);
        textViewATHStav = (TextView) view.findViewById(R.id.textViewATHStav);

        buttonATHStav = (Button) view.findViewById(R.id.buttonATHStav);
        buttonATHNastav = (Button) view.findViewById(R.id.buttonATHNastav);

        rbZAK = (RadioButton) view.findViewById(R.id.rbZAK);
        rbVAK = (RadioButton) view.findViewById(R.id.rbVAK);
        popisATHAKUStav = (TextView) view.findViewById(R.id.popisATHAKUStav);
        rbTON = (RadioButton) view.findViewById(R.id.rbTON);
        rbTOV = (RadioButton) view.findViewById(R.id.rbTOV);
        popisATHAKUtepStav = (TextView) view.findViewById(R.id.popisATHAKUtepStav);
        rbZTL = (RadioButton) view.findViewById(R.id.rbZTL);
        rbVTL = (RadioButton) view.findViewById(R.id.rbVTL);
        popisATHTLOStav = (TextView) view.findViewById(R.id.popisATHTLOStav);
        rbTLN = (RadioButton) view.findViewById(R.id.rbTLN);
        rbTLV = (RadioButton) view.findViewById(R.id.rbTLV);
        popisATHTLOtepStav = (TextView) view.findViewById(R.id.popisATHTLOtepStav);
        rbZTK = (RadioButton) view.findViewById(R.id.rbZTK);
        rbVTK = (RadioButton) view.findViewById(R.id.rbVTK);
        popisATHTKOStav = (TextView) view.findViewById(R.id.popisATHTKOStav);
        rbZBO = (RadioButton) view.findViewById(R.id.rbZBO);
        rbVBO = (RadioButton) view.findViewById(R.id.rbVBO);
        popisATHBOJStav = (TextView) view.findViewById(R.id.popisATHBOJStav);
        switchService = (Switch) view.findViewById(R.id.switchService);

        buttonATHStav.setOnClickListener(new View.OnClickListener() {
            public void onClick(View v) {
                // Do something in response to button click
                preferences = PreferenceManager.getDefaultSharedPreferences(getActivity());

                if (!switchService.isChecked())
                {
                    //HTTP request
                    textViewATHHistory.setText("Čekám na odpověď...");
                    preferences.edit().putString("textViewATHStavLastOK", textViewATHStav.getText().toString()).apply();
                    textViewATHStav.setText("Aktualizuji stav přes HTTPS...");
                    Uri.Builder builder = new Uri.Builder();
                    builder.appendQueryParameter("prikaz", "ATH INFO");
                    builder.appendQueryParameter("pocet", preferences.getString("pref_edit_max_history", "5"))
                            .appendQueryParameter("auth_login", preferences.getString("pref_edit_url_name", "guest"))
                            .appendQueryParameter("auth_heslo", preferences.getString("pref_edit_url_heslo", "guest"));
                    String query = builder.build().getEncodedQuery();
                    Long timestampATH = System.currentTimeMillis();
                    preferences.edit().putLong("timestampATH", timestampATH).apply();
                    preferences.edit().putBoolean("progressATH", true).apply();
                    new ChataRemoteRequest(getActivity(), "ATH", timestampATH).execute("https://chata.majner.cz/remote/remote.php", query);
                }
                else {
                    //SMS request
                    textViewATHHistory.setText("Čekám na odpověď...");
                    preferences.edit().putString("textViewATHStavLastOK", textViewATHStav.getText().toString()).apply();
                    textViewATHStav.setText("Aktualizuji stav přes SMS...");
                    String telNumber = preferences.getString("pref_edit_ath_tel_number", "+420720511131");//"+420720511131"
                    String smsText = "&"+ preferences.getString("pref_edit_ath_sms_heslo", "heslo")+"/port?/";
                    Long timestampATH = System.currentTimeMillis();
                    preferences.edit().putLong("timestampATH", timestampATH).apply();
                    preferences.edit().putBoolean("progressATH", true).apply();
                    new AthSmsRequest(getActivity(), "ATH", timestampATH).execute(telNumber, smsText);
                }
            }
        });

        buttonATHNastav.setOnClickListener(new View.OnClickListener() {
            public void onClick(View v) {
                preferences = PreferenceManager.getDefaultSharedPreferences(getActivity());

                if (!switchService.isChecked())
                {
                    //HTTP_request
                    textViewATHHistory.setText("Čekám na odpověď...");
                    preferences.edit().putString("textViewATHStavLastOK", textViewATHStav.getText().toString()).apply();
                    textViewATHStav.setText("Aktualizuji stav přes HTTPS...");
                    Uri.Builder builder = new Uri.Builder();
                    builder.appendQueryParameter("prikaz", "ATH NASTAV");
                    builder.appendQueryParameter("pocet", preferences.getString("pref_edit_max_history", "5"))
                            .appendQueryParameter("auth_login", preferences.getString("pref_edit_url_name", "guest"))
                            .appendQueryParameter("auth_heslo", preferences.getString("pref_edit_url_heslo", "guest"));
                    if (rbZAK.isChecked()) {builder.appendQueryParameter("aku_obyvak", "ZAK");}
                    if (rbVAK.isChecked()) {builder.appendQueryParameter("aku_obyvak", "VAK");}
                    if (rbTOV.isChecked()) {builder.appendQueryParameter("teplota_obyvak", "TOV");}
                    if (rbTON.isChecked()) {builder.appendQueryParameter("teplota_obyvak", "TON");}
                    if (rbZTL.isChecked()) {builder.appendQueryParameter("aku_loznice", "ZTL");}
                    if (rbVTL.isChecked()) {builder.appendQueryParameter("aku_loznice", "VTL");}
                    if (rbTLV.isChecked()) {builder.appendQueryParameter("teplota_loznice", "TLV");}
                    if (rbTLN.isChecked()) {builder.appendQueryParameter("teplota_loznice", "TLN");}
                    if (rbZTK.isChecked()) {builder.appendQueryParameter("topeni_koupelna", "ZTK");}
                    if (rbVTK.isChecked()) {builder.appendQueryParameter("topeni_koupelna", "VTK");}
                    if (rbZBO.isChecked()) {builder.appendQueryParameter("bojler_koupelna", "ZBO");}
                    if (rbVBO.isChecked()) {builder.appendQueryParameter("bojler_koupelna", "VBO");}
                    String query = builder.build().getEncodedQuery();
                    Long timestampATH = System.currentTimeMillis();
                    preferences.edit().putLong("timestampATH", timestampATH).apply();
                    preferences.edit().putBoolean("progressATH", true).apply();
                    new ChataRemoteRequest(getActivity(), "ATH", timestampATH).execute("https://chata.majner.cz/remote/remote.php", query);
                }
                else {
                    //SMS_request
                    textViewATHHistory.setText("Čekám na odpověď...");
                    preferences.edit().putString("textViewATHStavLastOK", textViewATHStav.getText().toString()).apply();
                    textViewATHStav.setText("Aktualizuji stav přes SMS...");

                }
            }
        });


        return view;
    }

    @Override
    public void onResume() {
        super.onResume();
        //Boolean butt=preferences.getBoolean("buttons", true);
        //String toustik= "Reason:" + ATHTerminateReason + "\n"+progressATH.toString()+ "\n"+butt.toString()+ "\n"+commandID+ "="+ timestampATH+ "\n"+vysledek;
        //Toast.makeText(getActivity(), "resume", Toast.LENGTH_SHORT).show();

        getActivity().registerReceiver(receiver, new IntentFilter(NOTIFICATION));
        getActivity().registerReceiver(receiver, new IntentFilter(NOTIFICATION + ".ATH"));
        getActivity().registerReceiver(receiver, new IntentFilter(CONNECTIVITY));
        cm = (ConnectivityManager) getActivity().getSystemService(Context.CONNECTIVITY_SERVICE);
        updateNetworkStatus();
        TelephonyManager tm = (TelephonyManager) getActivity().getSystemService(Context.TELEPHONY_SERVICE);
        tm.listen(new PhoneStateListener() {
            @Override
            public void onServiceStateChanged(ServiceState serviceState) {
                super.onServiceStateChanged(serviceState);
                String phonestate;

                switch (serviceState.getState()) {
                    case ServiceState.STATE_EMERGENCY_ONLY:
                        phonestate = "emergency.";
                        textViewStavSMS.setTextColor(Color.RED);
                        break;
                    case ServiceState.STATE_IN_SERVICE:
                        phonestate = "připojeno.";
                        textViewStavSMS.setTextColor(textViewATHStav.getTextColors());
                        break;
                    case ServiceState.STATE_OUT_OF_SERVICE:
                        phonestate = "odpojeno.";
                        textViewStavSMS.setTextColor(Color.RED);
                        break;
                    case ServiceState.STATE_POWER_OFF:
                        phonestate = "vypnuto.";
                        textViewStavSMS.setTextColor(Color.RED);
                        break;
                    default:
                        phonestate = "neznámé.";
                        textViewStavSMS.setTextColor(Color.RED);
                        break;
                }
                textViewStavSMS.setText(phonestate);
            }
        }, PhoneStateListener.LISTEN_SERVICE_STATE);

        preferences = PreferenceManager.getDefaultSharedPreferences(getActivity());
        //String ATHTerminateReason = preferences.getString("ATHTerminateReason", null);

        //osetrit pripad, kdy obnovuji stav pri spustenem dotazu ChataRemoteRequest
        //v opacnem pripade obycejne obnoveni
        obnovStavATHViewPref();
        Long commandID = preferences.getLong("commandID.ATH", 0);
        Long timestampATH = preferences.getLong("timestampATH", 1);
        String vysledek = preferences.getString("vysledek.ATH", "");
        Boolean progressATH = preferences.getBoolean("progressATH", false);
        if (progressATH && commandID.equals(timestampATH)) {
            zpracujATHVysledek(vysledek);
            //Toast.makeText(getActivity(),"zpracovavam", Toast.LENGTH_LONG).show();
        }

    }

    @Override
    public void onDestroy() {
        super.onDestroy();
        //getActivity().unregisterReceiver(receiver);
        //Toast.makeText(getActivity(), "Destroy",Toast.LENGTH_SHORT).show();
    }

    public void onPause() {
        super.onPause();
        //Toast.makeText(getActivity(), "Pause",Toast.LENGTH_SHORT).show();
        getActivity().unregisterReceiver(receiver);
        ulozStavATHViewPref();
    }

    private void updateNetworkStatus() {
        if (cm != null) {
            NetworkInfo activeNetwork = cm.getActiveNetworkInfo();
            if (activeNetwork != null && activeNetwork.isAvailable() && activeNetwork.isConnected()) {
                popisATHInternetStav.setText("připojeno.");
                popisATHInternetStav.setTextColor(textViewATHStav.getTextColors());
            } else {
                popisATHInternetStav.setText("nepřipojeno.");
                popisATHInternetStav.setTextColor(Color.RED);
            }
        }
    }

    public void nastavATHButtony(Boolean pozadovanyStav) {
        buttonATHStav.setEnabled(pozadovanyStav);
        buttonATHNastav.setEnabled(pozadovanyStav);
    }

    public void ulozStavATHViewPref() {
        preferences = PreferenceManager.getDefaultSharedPreferences(getActivity());
        //stav aktualizace
        preferences.edit().putString("textViewATHStav", textViewATHStav.getText().toString()).apply();
        //vyber metody komunikace
        preferences.edit().putBoolean("switchService", switchService.isChecked()).apply();
        //obyvak
        preferences.edit().putBoolean("rbZAK", rbZAK.isChecked()).apply();
        preferences.edit().putBoolean("rbVAK", rbVAK.isChecked()).apply();
        preferences.edit().putBoolean("rbTOV", rbTOV.isChecked()).apply();
        preferences.edit().putBoolean("rbTON", rbTON.isChecked()).apply();
        preferences.edit().putString("popisATHAKUStav", popisATHAKUStav.getText().toString()).apply();
        preferences.edit().putString("popisATHAKUtepStav", popisATHAKUtepStav.getText().toString()).apply();
        //loznice
        preferences.edit().putBoolean("rbZTL", rbZTL.isChecked()).apply();
        preferences.edit().putBoolean("rbVTL", rbVTL.isChecked()).apply();
        preferences.edit().putBoolean("rbTLN", rbTLN.isChecked()).apply();
        preferences.edit().putBoolean("rbTLV", rbTLV.isChecked()).apply();
        preferences.edit().putString("popisATHTLOStav", popisATHTLOStav.getText().toString()).apply();
        preferences.edit().putString("popisATHTLOtepStav", popisATHTLOtepStav.getText().toString()).apply();
        //koupelna
        preferences.edit().putBoolean("rbZTK", rbZTK.isChecked()).apply();
        preferences.edit().putBoolean("rbVTK", rbVTK.isChecked()).apply();
        preferences.edit().putBoolean("rbZBO", rbZBO.isChecked()).apply();
        preferences.edit().putBoolean("rbVBO", rbVBO.isChecked()).apply();
        preferences.edit().putString("popisATHTKOStav", popisATHTKOStav.getText().toString()).apply();
        preferences.edit().putString("popisATHBOJStav", popisATHBOJStav.getText().toString()).apply();
        //historie
        preferences.edit().putString("textViewATHHistory", textViewATHHistory.getText().toString()).apply();
    }

    public void obnovStavATHViewPref() {
        preferences = PreferenceManager.getDefaultSharedPreferences(getActivity());
        //stav aktualizace
        textViewATHStav.setText(preferences.getString("textViewATHStav", "Neaktualizováno."));
        //vyber metody komunikace
        switchService.setChecked(preferences.getBoolean("switchService", false));
        //obyvak
        rbZAK.setChecked(preferences.getBoolean("rbZAK", false));
        rbVAK.setChecked(preferences.getBoolean("rbVAK", false));
        rbTOV.setChecked(preferences.getBoolean("rbTOV", false));
        rbTON.setChecked(preferences.getBoolean("rbTON", false));
        popisATHAKUStav.setText(preferences.getString("popisATHAKUStav", "neznámé"));
        if (popisATHAKUStav.getText().equals("ZAP")) {popisATHAKUStav.setBackgroundColor(0xff00ff00);}
        if (popisATHAKUStav.getText().equals("VYP")) {popisATHAKUStav.setBackgroundColor(0xffff0000);}
        popisATHAKUtepStav.setText(preferences.getString("popisATHAKUtepStav", "neznámé"));
        if (popisATHAKUtepStav.getText().equals("+22oC")) {popisATHAKUtepStav.setTextColor(0xffff0000);}
        if (popisATHAKUtepStav.getText().equals("+5oC")) {popisATHAKUtepStav.setTextColor(0xff0000ff);}
        //loznice
        rbZTL.setChecked(preferences.getBoolean("rbZTL", false));
        rbVTL.setChecked(preferences.getBoolean("rbVTL", false));
        rbTLV.setChecked(preferences.getBoolean("rbTLV", false));
        rbTLN.setChecked(preferences.getBoolean("rbTLN", false));
        popisATHTLOStav.setText(preferences.getString("popisATHTLOStav", "neznámé"));
        if (popisATHTLOStav.getText().equals("ZAP")) {popisATHTLOStav.setBackgroundColor(0xff00ff00);}
        if (popisATHTLOStav.getText().equals("VYP")) {popisATHTLOStav.setBackgroundColor(0xffff0000);}
        popisATHTLOtepStav.setText(preferences.getString("popisATHTLOtepStav", "neznámé"));
        if (popisATHTLOtepStav.getText().equals("+22oC")) {popisATHTLOtepStav.setTextColor(0xffff0000);}
        if (popisATHTLOtepStav.getText().equals("+8oC")) {popisATHTLOtepStav.setTextColor(0xff0000ff);}
        //koupelna
        rbZTK.setChecked(preferences.getBoolean("rbZTK", false));
        rbVTK.setChecked(preferences.getBoolean("rbVTK", false));
        rbZBO.setChecked(preferences.getBoolean("rbZBO", false));
        rbVBO.setChecked(preferences.getBoolean("rbVBO", false));
        popisATHTKOStav.setText(preferences.getString("popisATHTKOStav", "neznámé"));
        if (popisATHTKOStav.getText().equals("ZAP")) {popisATHTKOStav.setBackgroundColor(0xff00ff00);}
        if (popisATHTKOStav.getText().equals("VYP")) {popisATHTKOStav.setBackgroundColor(0xffff0000);}
        popisATHBOJStav.setText(preferences.getString("popisATHBOJStav", "neznámé"));
        if (popisATHBOJStav.getText().equals("ZAP")) {popisATHBOJStav.setBackgroundColor(0xff00ff00);}
        if (popisATHBOJStav.getText().equals("VYP")) {popisATHBOJStav.setBackgroundColor(0xffff0000);}
        //historie
        textViewATHHistory.setText(preferences.getString("textViewATHHistory", "HISTORIE:"));
        //tlacitka
        Boolean butt=preferences.getBoolean("buttons", true);
        nastavATHButtony(butt);
    }

    public void zpracujATHVysledek (String vysledek) {
        preferences = PreferenceManager.getDefaultSharedPreferences(getActivity());
        //Toast.makeText(getActivity(), toustik, Toast.LENGTH_LONG).show();
        //info o stavu aktualizace
        Long timestampATH = preferences.getLong("timestampATH", 1);
        String currentDateandTime = DateFormat.getDateTimeInstance().format(new Date(timestampATH));
        if (!vysledek.contains("FAILED") && !vysledek.contains("Neplatn")) {
            textViewATHStav.setText("Stav k " + currentDateandTime + ".");
        }
        //obyvak
        if (vysledek.contains("AKO=ZAK/<BR>")) {
            rbZAK.setChecked(true);
            rbVAK.setChecked(false);
            popisATHAKUStav.setText("ZAP");
            popisATHAKUStav.setBackgroundColor(0xff00ff00);
        }
        if (vysledek.contains("AKO=VAK/<BR>")) {
            rbZAK.setChecked(false);
            rbVAK.setChecked(true);
            popisATHAKUStav.setText("VYP");
            popisATHAKUStav.setBackgroundColor(0xffff0000);
        }
        if (vysledek.contains("TEO=TON/<BR>")) {
            rbTON.setChecked(true);
            rbTOV.setChecked(false);
            popisATHAKUtepStav.setText("+5oC");
            popisATHAKUtepStav.setTextColor(0xff0000ff);
        }
        if (vysledek.contains("TEO=TOV/<BR>")) {
            rbTON.setChecked(false);
            rbTOV.setChecked(true);
            popisATHAKUtepStav.setText("+22oC");
            popisATHAKUtepStav.setTextColor(0xffff0000);
        }
        //loznice
        if (vysledek.contains("TLO=ZTL/<BR>")) {
            rbZTL.setChecked(true);
            rbVTL.setChecked(false);
            popisATHTLOStav.setText("ZAP");
            popisATHTLOStav.setBackgroundColor(0xff00ff00);
        }
        if (vysledek.contains("TLO=VTL/<BR>")) {
            rbZTL.setChecked(false);
            rbVTL.setChecked(true);
            popisATHTLOStav.setText("VYP");
            popisATHTLOStav.setBackgroundColor(0xffff0000);
        }
        if (vysledek.contains("TEL=TLN/<BR>")) {
            rbTLN.setChecked(true);
            rbTLV.setChecked(false);
            popisATHTLOtepStav.setText("+8oC");
            popisATHTLOtepStav.setTextColor(0xff0000ff);
        }
        if (vysledek.contains("TEL=TLV/<BR>")) {
            rbTLN.setChecked(false);
            rbTLV.setChecked(true);
            popisATHTLOtepStav.setText("+22oC");
            popisATHTLOtepStav.setTextColor(0xffff0000);
        }
        //koupelna
        if (vysledek.contains("TKO=ZTK/<BR>")) {
            rbZTK.setChecked(true);
            rbVTK.setChecked(false);
            popisATHTKOStav.setText("ZAP");
            popisATHTKOStav.setBackgroundColor(0xff00ff00);
        }
        if (vysledek.contains("TKO=VTK/<BR>")) {
            rbZTK.setChecked(false);
            rbVTK.setChecked(true);
            popisATHTKOStav.setText("VYP");
            popisATHTKOStav.setBackgroundColor(0xffff0000);
        }
        if (vysledek.contains("BOJ=ZBO/<BR>")) {
            rbZBO.setChecked(true);
            rbVBO.setChecked(false);
            popisATHBOJStav.setText("ZAP");
            popisATHBOJStav.setBackgroundColor(0xff00ff00);
        }
        if (vysledek.contains("BOJ=VBO/<BR>")) {
            rbZBO.setChecked(false);
            rbVBO.setChecked(true);
            popisATHBOJStav.setText("VYP");
            popisATHBOJStav.setBackgroundColor(0xffff0000);
        }
        //historie
        //Integer indexVchod = vysledek.lastIndexOf("VCHOD=");
        //Integer indexVeranda = vysledek.lastIndexOf("VERANDA=");


        //HTTPS historie
        String pocetH = preferences.getString("pref_edit_max_history", "5");
        if (vysledek.lastIndexOf("Prezdivka")>0) {
            textViewATHHistory.setText("HISTORIE:\n");
            for (int i = 0; i < Integer.valueOf(pocetH); ++i) {
                Integer indexN = vysledek.indexOf("N" + Integer.toString(i) + "=") + ("N" + Integer.toString(i) + "=").length();
                String n = vysledek.substring(indexN, vysledek.indexOf("<BR>", indexN));
                Integer indexDatum = vysledek.indexOf("Datum" + Integer.toString(i) + "=") + ("Datum" + Integer.toString(i) + "=").length();
                String datum = vysledek.substring(indexDatum, vysledek.indexOf("<BR>", indexDatum));
                Integer indexCas = vysledek.indexOf("Cas" + Integer.toString(i) + "=") + ("Cas" + Integer.toString(i) + "=").length();
                String cas = vysledek.substring(indexCas, vysledek.indexOf("<BR>", indexCas));
                Integer indexPrezdivka = vysledek.indexOf("Prezdivka" + Integer.toString(i) + "=") + ("Prezdivka" + Integer.toString(i) + "=").length();
                String prezdivka = vysledek.substring(indexPrezdivka, vysledek.indexOf("<BR>", indexPrezdivka));
                Integer indexDotaz = vysledek.indexOf("Dotaz" + Integer.toString(i) + "=") + ("Dotaz" + Integer.toString(i) + "=").length() +6;
                String dotaz = vysledek.substring(indexDotaz, vysledek.indexOf("\n<BR>", indexDotaz));
                Integer indexOdpoved = vysledek.indexOf("Odpoved" + Integer.toString(i) + "=") + ("Odpoved" + Integer.toString(i) + "=").length();
                String odpoved = vysledek.substring(indexOdpoved, vysledek.indexOf("\n<BR>", indexOdpoved));
                textViewATHHistory.setText(textViewATHHistory.getText() + n + ". " + datum + " " + cas + " " + prezdivka + "\n"+ "   " + dotaz + "\n"+ "   " + odpoved+ "\n");
            }
        }
        //SMS historie
        if (vysledek.contains("SMS_ANSWER:")) {
            textViewATHHistory.setText("ODPOVĚĎ Z ATH:\n" + vysledek);
        }

        if (vysledek.contains("FAILED1") || vysledek.contains("FAILED2")) {
            textViewATHHistory.setText(textViewATHHistory.getText() + currentDateandTime + ": Chyba komunikace se serverem!" + "\n");
            textViewATHStav.setText(preferences.getString("textViewATHStavLastOK", "Neaktualizováno."));
        }
        if (vysledek.contains("Neplatn")) {
            textViewATHHistory.setText(textViewATHHistory.getText() + currentDateandTime + ": Neplatná autorizace!" + "\n");
            textViewATHStav.setText(preferences.getString("textViewATHStavLastOK", "Neaktualizováno."));
        }
        if (vysledek.contains("SMS_ERROR:")) {
            textViewATHHistory.setText(textViewATHHistory.getText() + currentDateandTime + ": Chyba při odesílání SMS!" + "\n"+ vysledek +"\n");
            textViewATHStav.setText(preferences.getString("textViewATHStavLastOK", "Neaktualizováno."));
        }

        preferences.edit().putBoolean("progressATH", false).apply();
    }

}