package cz.majner.chata.nasechata;


import android.content.Intent;
import android.content.SharedPreferences;
import android.preference.PreferenceManager;
import android.support.v7.app.ActionBarActivity;
import android.support.v7.app.ActionBar;
import android.support.v4.app.FragmentTransaction;
import android.support.v4.app.FragmentPagerAdapter;
import android.os.Bundle;
import android.support.v4.view.ViewPager;
import android.view.Menu;
import android.view.MenuItem;
//import android.widget.Toast;


public class MainActivity extends ActionBarActivity implements ActionBar.TabListener {

    /**
     * The {@link android.support.v4.view.PagerAdapter} that will provide
     * fragments for each of the sections. We use a
     * {@link FragmentPagerAdapter} derivative, which will keep every
     * loaded fragment in memory. If this becomes too memory intensive, it
     * may be best to switch to a
     * {@link android.support.v4.app.FragmentStatePagerAdapter}.
     */
    SectionsPagerAdapter mSectionsPagerAdapter;
    SharedPreferences preferences;
    public static final String NOTIFICATION = "cz.majner.chata.nasechata.CHATA_REMOTE_REQUEST";


    //public Bundle bundleQuido;

    /**
     * The {@link ViewPager} that will host the section contents.
     */
    ViewPager mViewPager;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);

        // Set up the action bar.
        final ActionBar actionBar = getSupportActionBar();
        actionBar.setNavigationMode(ActionBar.NAVIGATION_MODE_TABS);

        // Create the adapter that will return a fragment for each of the three
        // primary sections of the activity.
        mSectionsPagerAdapter = new SectionsPagerAdapter(getSupportFragmentManager());

        // Set up the ViewPager with the sections adapter.
        mViewPager = (ViewPager) findViewById(R.id.pager);
        mViewPager.setAdapter(mSectionsPagerAdapter);

        // When swiping between different sections, select the corresponding
        // tab. We can also use ActionBar.Tab#select() to do this if we have
        // a reference to the Tab.
        mViewPager.setOnPageChangeListener(new ViewPager.SimpleOnPageChangeListener() {
            @Override
            public void onPageSelected(int position) {
                actionBar.setSelectedNavigationItem(position);
            }
        });

        actionBar.addTab(actionBar.newTab().setText("POČASÍ").setTabListener(this));
        actionBar.addTab(actionBar.newTab().setText("TOPENÍ").setTabListener(this));
        actionBar.addTab(actionBar.newTab().setText("SVĚTLO").setTabListener(this));
        actionBar.addTab(actionBar.newTab().setText("SERVIS").setTabListener(this));

    }



    @Override
    public void onPause() {
        super.onPause();
        //locationManager.removeUpdates(this);
        preferences = PreferenceManager.getDefaultSharedPreferences(this);
        preferences.edit().putInt("tabState", getSupportActionBar().getSelectedNavigationIndex()).apply();

    }

    @Override
    public void onResume() {
        super.onResume();
        preferences = PreferenceManager.getDefaultSharedPreferences(this);
        Integer tabState= preferences.getInt("tabState", 0);
        getSupportActionBar().setSelectedNavigationItem(tabState);

    }


    @Override
    protected void onSaveInstanceState(Bundle outState) {

        super.onSaveInstanceState(outState);
        preferences = PreferenceManager.getDefaultSharedPreferences(this);
        preferences.edit().putInt("tabState", getSupportActionBar().getSelectedNavigationIndex()).apply();
    }

    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        // Inflate the menu; this adds items to the action bar if it is present.
        getMenuInflater().inflate(R.menu.menu_main, menu);
        return true;
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        // Handle action bar item clicks here. The action bar will
        // automatically handle clicks on the Home/Up button, so long
        // as you specify a parent activity in AndroidManifest.xml.
        int id = item.getItemId();

        //noinspection SimplifiableIfStatement
        if (id == R.id.action_settings) {

            Intent intent = new Intent();
            intent.setClass(this, PrefsActivity.class);
            startActivityForResult(intent, 0);
            //finish();
            return true;
        }
        if (id == R.id.reset_buttons) {

            Intent intent3 = new Intent(NOTIFICATION);
            intent3.putExtra("button_status", "true");
            this.sendBroadcast(intent3);

            return true;
        }
        if (id == R.id.action_about) {

            Intent intent = new Intent(this, AboutActivity.class);
            //intent.setClass(this, AboutActivity.class);
            startActivity(intent);
            //finish();
            return true;
        }
        if (id == R.id.action_exit) {

            this.finish();
            android.os.Process.killProcess(android.os.Process.myPid());
            //System.exit(0);
            //return true;
        }

        return super.onOptionsItemSelected(item);
    }

    @Override
    public void onTabSelected(ActionBar.Tab tab, FragmentTransaction fragmentTransaction) {
        // When the given tab is selected, switch to the corresponding page in
        // the ViewPager.
        mViewPager.setCurrentItem(tab.getPosition());
        //Toast.makeText(this,"ss", Toast.LENGTH_LONG).show();
    }

    @Override
    public void onTabUnselected(ActionBar.Tab tab, FragmentTransaction fragmentTransaction) {
    }

    @Override
    public void onTabReselected(ActionBar.Tab tab, FragmentTransaction fragmentTransaction) {
    }



}
